       IDENTIFICATION DIVISION.
       PROGRAM-ID.    DEMONTCB.
       AUTHOR.        AG-TECH Corp.
      *------------------------------------------
      * Actian Zen (Btrieve Level)
      * Demonstration Program
      * xm NetCOBOL for Windows 
      * Copyright (c) 1988-2021 by AG-TECH CORP.
      *------------------------------------------
       ENVIRONMENT DIVISION.
        CONFIGURATION SECTION.
        SPECIAL-NAMES.
            CONSOLE IS CONS.
      *
      *==========================================
      *
      *    D A T A   D I V I S I O N
      *
      *==========================================
       DATA DIVISION.
       WORKING-STORAGE SECTION.
      *------------------------------------------
      *    Btrieve Data File Structure
      *------------------------------------------
       01  CUST-REC.
           02  CUST-CODE                         PIC X(6).
           02  CUST-NAME                         PIC X(14).
           02  CUST-FURIGANA                     PIC X(10).
           02  CUST-ZIP                          PIC X(8).
           02  CUST-ADDR1                        PIC X(30).
           02  CUST-ADDR2                        PIC X(30).
           02  CUST-BIRTHDAY                     PIC X(10).
      *------------------------------------------
      *    Btrieve Operation Codes
      *------------------------------------------
       77  B-OPEN               PIC 9999 COMP-5         VALUE 0.
       77  B-CLOSE              PIC 9999 COMP-5         VALUE 1.
       77  B-INSERT             PIC 9999 COMP-5         VALUE 2.
       77  B-UPDATE             PIC 9999 COMP-5         VALUE 3.
       77  B-DELETE             PIC 9999 COMP-5         VALUE 4.
       77  B-GETEQ              PIC 9999 COMP-5         VALUE 5.
       77  B-GETNEXT            PIC 9999 COMP-5         VALUE 6.
       77  B-GETPREV            PIC 9999 COMP-5         VALUE 7.
       77  B-GETGE              PIC 9999 COMP-5         VALUE 9.
       77  B-GETFIRST           PIC 9999 COMP-5         VALUE 12.
       77  B-GETLAST            PIC 9999 COMP-5         VALUE 13.
       77  B-STOP               PIC 9999 COMP-5         VALUE 25.
      *------------------------------------------
      *    Variables for Btrieve
      *------------------------------------------
       77  B-STAT               PIC 9999 COMP-5.
       77  B-KEY-VALUE          PIC X(255).
       77  B-KEY-NO             PIC 9999 COMP-5.
       77  B-BUF-LEN            PIC 9(9) COMP-5.
       77  B-OPEN-MODE          PIC S9999 COMP-5        VALUE 0.
       77  B-POS-BLOCK          PIC X(128).
      *------------------------------------------
      *    Other Variables
      *------------------------------------------
       77  CHOICE-NO            PIC 9.
       77  CHOICE-CHR           PIC X.
       77  END-FLAG             PIC 9            VALUE 0.
       77  PROC-FLAG            PIC 9.
       77  DISP-STAT            PIC 9999.
       77  EDITED               PIC 9.
       77  OPERATION            PIC 9999         COMP-5.
      *
      *==========================================
      *
      *    P R O C E D U R E   D I V I S I O N
      *
      *==========================================
       PROCEDURE DIVISION.
       MAIN.
           DISPLAY      SPACE.
           PERFORM      OPEN-DB.
           PERFORM      SELECT-MENU     UNTIL END-FLAG = 1.
           PERFORM      CLOSE-DB.
           STOP RUN.
      *    --------------------------------------
      *    Btrieve t@CEI[v
      *    --------------------------------------
       OPEN-DB.
           MOVE         0       TO      B-BUF-LEN.
           MOVE "SAMPLEDATA.MKD "   TO      B-KEY-VALUE.
           CALL "_BTRV" USING   B-OPEN, B-STAT, B-POS-BLOCK, CUST-REC,
                                B-BUF-LEN, B-KEY-VALUE, B-OPEN-MODE.
           IF   B-STAT  NOT =   ZERO
                        DISPLAY "t@CI[vł܂"
                        PERFORM ERROR-DISP
                                STOP RUN.
      *    --------------------------------------
      *    Btrieve t@CEN[YƎ̉
      *    --------------------------------------
       CLOSE-DB.
           CALL "_BTRV" USING   B-CLOSE, B-STAT, B-POS-BLOCK, CUST-REC,
                                B-BUF-LEN, B-KEY-VALUE, B-OPEN-MODE.
           IF   B-STAT  NOT =   ZERO
                        DISPLAY "t@C𐳂N[Ył܂"
                        PERFORM    ERROR-DISP
           CALL "_BTRV" USING   B-STOP, B-STAT, B-POS-BLOCK, CUST-REC,
                                B-BUF-LEN, B-KEY-VALUE, B-OPEN-MODE.
           IF   B-STAT  NOT =   ZERO
                        DISPLAY "STOPł܂"
                        PERFORM    ERROR-DISP
                        STOP RUN.
      *    --------------------------------------
      *    I
      *    --------------------------------------
       SELECT-MENU.
           PERFORM      DISP-MENU.
           MOVE         0       TO      CHOICE-NO  PROC-FLAG.
           PERFORM      SELECT-CHOICE-NO
                                UNTIL   CHOICE-NO > 0 AND
                                        CHOICE-NO < 6.
           IF  CHOICE-NO = 1    
                        PERFORM INSERT-DATA
                                UNTIL   PROC-FLAG = 1
           ELSE IF CHOICE-NO = 2
                        PERFORM UPDATE-DATA
                                UNTIL   PROC-FLAG = 1
           ELSE IF CHOICE-NO = 3
                        PERFORM DELETE-DATA
                                UNTIL   PROC-FLAG = 1
           ELSE IF CHOICE-NO = 4
                        PERFORM SEARCH-DATA
                                UNTIL   PROC-FLAG = 1
           ELSE
                        MOVE    1   TO  END-FLAG.
      *    --------------------------------------
      *    j[ʕ\
      *    --------------------------------------
       DISP-MENU.
           DISPLAY SPACE
           DISPLAY 
           "Demonstration Program (c) 1988-2021 by AG-TECH CORP."
           DISPLAY SPACE
           DISPLAY "<<< ڋqǗ fEvO >>>"
           DISPLAY SPACE
           DISPLAY "  1. VR[h̒ǉ"
           DISPLAY "  2. R[h̏CiR[hwj"
           DISPLAY "  3. R[h̍폜iR[hwj"
           DISPLAY "  4. R[ȟ"
           DISPLAY "  5. vOI"
           DISPLAY SPACE
           DISPLAY "ԍ͂Ă (1-5) :" WITH NO ADVANCING.
      *
      *    ----------------------------------------------------------
      *          === VKo^ ===
      *    ----------------------------------------------------------
      *
       INSERT-DATA.
           DISPLAY      "o^郌R[h̃f[^͂Ă"
           DISPLAY      "ڂ͍̌̐őoCgł"
           MOVE         SPACE   TO      CUST-REC.
           DISPLAY      "ڋqR[h (6) :" WITH NO ADVANCING.
           ACCEPT       CUST-CODE FROM CONS.
           DISPLAY      " (14) :" WITH NO ADVANCING.
           ACCEPT       CUST-NAME FROM CONS.
           DISPLAY      "tKi (10) :" WITH NO ADVANCING.
           ACCEPT       CUST-FURIGANA FROM CONS.
           DISPLAY      "X֔ԍ (8) :" WITH NO ADVANCING.
           ACCEPT       CUST-ZIP FROM CONS.
           DISPLAY      "ZP (30) :" WITH NO ADVANCING.
           ACCEPT       CUST-ADDR1 FROM CONS.
           DISPLAY      "ZQ (30) :" WITH NO ADVANCING.
           ACCEPT       CUST-ADDR2 FROM CONS.
           DISPLAY      "N [YYYY.MM.DD] (10) :" WITH NO ADVANCING.
           ACCEPT       CUST-BIRTHDAY FROM CONS.
           MOVE         108     TO      B-BUF-LEN.
           MOVE         0       TO      B-KEY-NO.
           CALL "_BTRV" USING   B-INSERT, B-STAT, B-POS-BLOCK, CUST-REC,
                                B-BUF-LEN, B-KEY-VALUE, B-KEY-NO.
           IF   B-STAT  NOT =   ZERO
                        DISPLAY "o^ł܂"
                        PERFORM ERROR-DISP
           ELSE
                        DISPLAY "o^܂".
           DISPLAY      "o^𑱂܂ ? (Y/N) " WITH NO ADVANCING
           MOVE         SPACE   TO      CHOICE-CHR.
           ACCEPT       CHOICE-CHR.
           IF  CHOICE-CHR NOT = "Y" AND CHOICE-CHR NOT = "y"
                        MOVE    1       TO      PROC-FLAG.
      *
      *    ----------------------------------------------------------
      *          === C ===
      *    ----------------------------------------------------------
      *
       UPDATE-DATA.
           MOVE         SPACE   TO      B-KEY-VALUE. 
           DISPLAY      "C郌R[ȟڋqR[h :" WITH NO ADVANCING
           ACCEPT       B-KEY-VALUE FROM CONS.
           MOVE         108     TO      B-BUF-LEN.
           MOVE         0       TO      B-KEY-NO.
           CALL "_BTRV" USING   B-GETEQ, B-STAT, B-POS-BLOCK, CUST-REC,
                                B-BUF-LEN, B-KEY-VALUE, B-KEY-NO.
           IF   B-STAT  NOT =  ZERO
                        DISPLAY "Yf[^͂܂"
                        PERFORM ERROR-DISP
           ELSE
                        MOVE    9       TO      CHOICE-NO
                        PERFORM UPDATE-FIELD
                                UNTIL   CHOICE-NO =     0
                        PERFORM UPDATE-RECORD.
           DISPLAY      "C𑱂܂ ? (Y/N) " WITH NO ADVANCING
           MOVE         SPACE   TO      CHOICE-CHR.
           ACCEPT       CHOICE-CHR.
           IF  CHOICE-CHR NOT = "Y" AND CHOICE-CHR NOT = "y"
                        MOVE    1   TO   PROC-FLAG.
      *    --------------------------------------
      *    ڂ̕ύX
      *    --------------------------------------
       UPDATE-FIELD.
           PERFORM      DISP-REC-WITH-NO.
           DISPLAY      "C鍀ڔԍ (1-7, 0=CI) :"
                          WITH NO ADVANCING.
           MOVE         0       TO      CHOICE-NO.
           ACCEPT       CHOICE-NO.
           IF  CHOICE-NO = 1
                        MOVE    SPACE   TO      CUST-CODE
                        DISPLAY         "ڋqR[h (6) :" WITH NO ADVANCING
                        ACCEPT          CUST-CODE FROM CONS
           ELSE IF CHOICE-NO = 2
                       MOVE     SPACE   TO      CUST-NAME
                       DISPLAY          " (14) :" WITH NO ADVANCING
                       ACCEPT           CUST-NAME FROM CONS
           ELSE IF CHOICE-NO = 3
                       MOVE     SPACE   TO      CUST-FURIGANA
                       DISPLAY          "tKi (10) :" WITH NO ADVANCING
                       ACCEPT           CUST-FURIGANA FROM CONS
           ELSE IF CHOICE-NO = 4
                       MOVE     SPACE   TO      CUST-ZIP
                       DISPLAY       "X֔ԍ (8) :" WITH NO ADVANCING
                       ACCEPT           CUST-ZIP FROM CONS
           ELSE IF CHOICE-NO = 5
                       MOVE     SPACE   TO      CUST-ADDR1
                       DISPLAY          "ZP (30) :" WITH NO ADVANCING
                       ACCEPT           CUST-ADDR1 FROM CONS
           ELSE IF CHOICE-NO = 6
                       MOVE     SPACE   TO      CUST-ADDR2
                       DISPLAY          "ZQ (30) :" WITH NO ADVANCING
                       ACCEPT           CUST-ADDR2 FROM CONS
           ELSE IF CHOICE-NO = 7
                       MOVE     SPACE   TO      CUST-BIRTHDAY
                       DISPLAY          "N [YYYY.MM.DD] (10) :"
                                          WITH NO ADVANCING
                       ACCEPT           CUST-BIRTHDAY FROM CONS.
      *    --------------------------------------
      *    o^f[^ʕ\iCpj
      *    --------------------------------------
       DISP-REC-WITH-NO.
           DISPLAY      "1. ڋqR[h : "      CUST-CODE
           DISPLAY      "2.        : "      CUST-NAME
           DISPLAY      "3. tKi   : "      CUST-FURIGANA
           DISPLAY      "4. X֔ԍ   : "      CUST-ZIP
           DISPLAY      "5. ZP     : "      CUST-ADDR1
           DISPLAY      "6. ZQ     : "      CUST-ADDR2
           DISPLAY      "7. N   : "      CUST-BIRTHDAY.
      *    --------------------------------------
      *    f[^̕ύXo^
      *    --------------------------------------
       UPDATE-RECORD.
           MOVE         0       TO      B-KEY-NO.
           MOVE         108     TO      B-BUF-LEN.
           CALL "_BTRV" USING   B-UPDATE, B-STAT, B-POS-BLOCK, CUST-REC,
                                B-BUF-LEN, B-KEY-VALUE, B-KEY-NO.
           IF   B-STAT NOT =    ZERO
                        DISPLAY "ύXł܂"
                        PERFORM ERROR-DISP
           ELSE
                        DISPLAY "ύX܂".
      *
      *    ----------------------------------------------------------
      *          === 폜 ===
      *    ----------------------------------------------------------
      *
       DELETE-DATA.
           MOVE        SPACE    TO      B-KEY-VALUE. 
           DISPLAY     "폜郌R[ȟڋqR[h :" WITH NO ADVANCING
           ACCEPT      B-KEY-VALUE FROM CONS.
           MOVE        108      TO      B-BUF-LEN.
           MOVE        0        TO      B-KEY-NO.
           CALL "_BTRV" USING   B-GETEQ, B-STAT, B-POS-BLOCK, CUST-REC,
                                B-BUF-LEN, B-KEY-VALUE, B-KEY-NO.
           IF   B-STAT  NOT =   ZERO
                        DISPLAY "Yf[^͂܂"
                        PERFORM ERROR-DISP
           ELSE
                        PERFORM DELETE-CONFIRM.
           DISPLAY      "폜𑱂܂ ? (Y/N) " WITH NO ADVANCING
           MOVE         SPACE   TO      CHOICE-CHR.
           ACCEPT       CHOICE-CHR.
           IF  CHOICE-CHR NOT = "Y" AND CHOICE-CHR NOT = "y"
                        MOVE    1       TO      PROC-FLAG.
      *
       DELETE-CONFIRM.
           PERFORM      DISP-REC.
           DISPLAY      "폜܂ (Y/N) " WITH NO ADVANCING
           MOVE         SPACE   TO      CHOICE-CHR.
           ACCEPT       CHOICE-CHR.
           IF  CHOICE-CHR = "Y" OR CHOICE-CHR = "y"
                CALL    "_BTRV"   USING B-DELETE, B-STAT, B-POS-BLOCK,
                        CUST-REC, B-BUF-LEN, B-KEY-VALUE, B-KEY-NO
                IF      B-STAT NOT =    ZERO
                        DISPLAY "폜ł܂"
                        PERFORM ERROR-DISP
               ELSE
                        DISPLAY "폜܂".
      *
      *    ----------------------------------------------------------
      *          ===  ===
      *    ----------------------------------------------------------
      *
       SEARCH-DATA.
           PERFORM      KEY-SELECT-MENU.
           MOVE         0       TO      CHOICE-NO.
           PERFORM      SELECT-CHOICE-NO
                                UNTIL   CHOICE-NO > 0 AND
                                        CHOICE-NO < 4.
           DISPLAY      "Jnl͂Ă :"
                          WITH NO ADVANCING
           MOVE         SPACE   TO      B-KEY-VALUE. 
           ACCEPT       B-KEY-VALUE FROM CONS.
           MOVE         108     TO      B-BUF-LEN.
           SUBTRACT     1       FROM    CHOICE-NO.
           MOVE         CHOICE-NO       TO      B-KEY-NO.
           CALL "_BTRV"  USING  B-GETGE, B-STAT, B-POS-BLOCK, CUST-REC,
                                B-BUF-LEN, B-KEY-VALUE, B-KEY-NO.
           MOVE         SPACE   TO      CHOICE-CHR.
           PERFORM      SEARCH-DISP     UNTIL   PROC-FLAG = 1.
      *    --------------------------------------
      *    L[̑Iʕ\
      *    --------------------------------------
       KEY-SELECT-MENU.
           DISPLAY      "f[^L[Ɍ܂".
           DISPLAY      SPACE.
           DISPLAY      "1. ڋqR[h"
           DISPLAY      "2. tKi"
           DISPLAY      "3. N"
           DISPLAY      SPACE.
           DISPLAY      "L[w肵Ă (1-3) :"
                          WITH NO ADVANCING.
      *    --------------------------------------
      *    f[^̌
      *    --------------------------------------
       SEARCH-DISP.
           IF   B-STAT NOT =    ZERO
                        DISPLAY "ł܂"
                        PERFORM ERROR-DISP
           ELSE         
                        PERFORM DISP-REC.
           MOVE         ZERO    TO      OPERATION.
           PERFORM      NEXT-COMMAND    UNTIL
                                        OPERATION NOT = ZERO.
           IF  PROC-FLAG NOT = 1
               CALL "_BTRV" USING  OPERATION, B-STAT, B-POS-BLOCK,
                        CUST-REC, B-BUF-LEN, B-KEY-VALUE, B-KEY-NO.
      *     -------------------------------------
      *     R}hI
      *     -------------------------------------
       NEXT-COMMAND.
           DISPLAY      "[N] ں [P] Oں [F] 擪ں "
                        "[L] ŏIں [X] I" WITH NO ADVANCING.
           MOVE         SPACE   TO      CHOICE-CHR.
           ACCEPT       CHOICE-CHR FROM SYSIN.
           IF  CHOICE-CHR = "N" OR CHOICE-CHR = "n"
                        MOVE    B-GETNEXT  TO  OPERATION
           ELSE IF  CHOICE-CHR = "P" OR CHOICE-CHR = "p"
                        MOVE    B-GETPREV  TO  OPERATION
           ELSE IF  CHOICE-CHR = "F" OR CHOICE-CHR = "f"
                        MOVE    B-GETFIRST TO  OPERATION
           ELSE IF  CHOICE-CHR = "L" OR CHOICE-CHR = "l"
                        MOVE    B-GETLAST  TO  OPERATION
           ELSE IF  CHOICE-CHR = "X" OR CHOICE-CHR = "x"
                        MOVE    99         TO  OPERATION
                        MOVE    1          TO  PROC-FLAG.
      *
      *    ----------------------------------------------------------
      *          === GENERAL SUBROUTINES ===
      *    ----------------------------------------------------------
      *
      *    --------------------------------------
      *    f[^̕\i폜 & pj
      *    --------------------------------------
       DISP-REC.
           DISPLAY      "ڋqR[h : " CUST-CODE
           DISPLAY      "       : " CUST-NAME
           DISPLAY      "tKi   : " CUST-FURIGANA
           DISPLAY      "X֔ԍ   : " CUST-ZIP
           DISPLAY      "ZP     : " CUST-ADDR1
           DISPLAY      "ZQ     : " CUST-ADDR2
           DISPLAY      "N   : " CUST-BIRTHDAY.
      *    --------------------------------------
      *    l̓
      *    --------------------------------------
       SELECT-CHOICE-NO.
           MOVE         0       TO      CHOICE-NO.
           ACCEPT       CHOICE-NO.
      *    --------------------------------------
      *    G[Xe[^X\
      *    -------------------------------------
       ERROR-DISP.
           MOVE         B-STAT  TO      DISP-STAT
           DISPLAY      "STATUS = "     DISP-STAT.
           ACCEPT       CHOICE-NO.

